Magisk/scripts/boot_patch.sh

183 lines
5.8 KiB
Bash
Raw Normal View History

2017-06-03 14:19:01 +02:00
#!/system/bin/sh
##########################################################################################
#
# Magisk Boot Image Patcher
# by topjohnwu
2017-07-24 20:02:19 +02:00
#
2017-07-09 18:17:34 +02:00
# This script should be placed in a directory with the following files:
2017-07-24 20:02:19 +02:00
#
2017-06-03 14:19:01 +02:00
# File name type Description
2017-07-24 20:02:19 +02:00
#
2017-06-03 14:19:01 +02:00
# boot_patch.sh script A script to patch boot. Expect path to boot image as parameter.
# (this file) The script will use binaries and files in its same directory
# to complete the patching process
# monogisk binary The monolithic binary to replace /init
2017-06-03 14:19:01 +02:00
# magiskboot binary A tool to unpack boot image, decompress ramdisk, extract ramdisk
2017-07-09 18:17:34 +02:00
# , and patch the ramdisk for Magisk support
# chromeos folder This folder should store all the utilities and keys to sign
# (optional) a chromeos device, used in the tablet Pixel C
2017-07-24 20:02:19 +02:00
#
2017-06-03 14:19:01 +02:00
# If the script is not running as root, then the input boot image should be a stock image
# or have a backup included in ramdisk internally, since we cannot access the stock boot
# image placed under /data we've created when previously installed
2017-06-03 14:19:01 +02:00
#
##########################################################################################
2017-06-24 16:38:20 +02:00
##########################################################################################
# Functions
##########################################################################################
2017-06-03 14:19:01 +02:00
2017-06-24 16:38:20 +02:00
# Pure bash dirname implementation
dirname_wrap() {
case "$1" in
*/*)
dir=${1%/*}
[ -z $dir ] && echo "/" || echo $dir
;;
*)
echo "."
;;
esac
2017-06-24 16:38:20 +02:00
}
# Pure bash basename implementation
basename_wrap() {
echo ${1##*/}
}
2017-06-03 14:19:01 +02:00
##########################################################################################
2017-06-24 16:38:20 +02:00
# Initialization
2017-06-03 14:19:01 +02:00
##########################################################################################
if [ -z $SOURCEDMODE ]; then
# Switch to the location of the script file
cd "`dirname_wrap "${BASH_SOURCE:-$0}"`"
# Load utility functions
. ./util_functions.sh
# Detect current status
mount_partitions
fi
2017-10-07 16:08:10 +02:00
BOOTIMAGE="$1"
[ -e "$BOOTIMAGE" ] || abort "$BOOTIMAGE does not exist!"
# Presets
[ -z $KEEPVERITY ] && KEEPVERITY=false
[ -z $HIGHCOMP ] && HIGHCOMP=false
2017-10-07 16:08:10 +02:00
if [ -z $KEEPFORCEENCRYPT ]; then
if [ "`getprop ro.crypto.state`" = "encrypted" ]; then
KEEPFORCEENCRYPT=true
ui_print "- Encrypted data detected"
else
KEEPFORCEENCRYPT=false
fi
fi
2017-09-02 17:24:34 +02:00
chmod -R 755 .
2017-06-03 14:19:01 +02:00
# Extract magisk if doesn't exist
2017-11-09 17:54:54 +01:00
[ -e magisk ] || ./magiskinit -x magisk magisk
2017-06-24 16:38:20 +02:00
##########################################################################################
# Unpack
##########################################################################################
2017-09-06 10:13:23 +02:00
2017-08-16 21:46:01 +02:00
CHROMEOS=false
2017-06-24 16:38:20 +02:00
2017-09-15 21:48:58 +02:00
ui_print "- Unpacking boot image"
2017-06-15 22:08:34 +02:00
./magiskboot --unpack "$BOOTIMAGE"
2017-06-03 14:19:01 +02:00
case $? in
1 )
2017-09-15 21:48:58 +02:00
abort "! Unable to unpack boot image"
2017-06-03 14:19:01 +02:00
;;
2 )
2017-12-06 05:51:16 +01:00
ui_print "! Insufficient boot partition size detected"
HIGHCOMP=true
2017-12-20 20:36:18 +01:00
ui_print "- Enable high compression mode"
2017-12-06 05:51:16 +01:00
;;
3 )
2017-10-07 16:08:10 +02:00
ui_print "- ChromeOS boot image detected"
CHROMEOS=true
;;
2017-12-06 05:51:16 +01:00
4 )
2017-09-15 21:48:58 +02:00
ui_print "! Sony ELF32 format detected"
abort "! Please use BootBridge from @AdrianDC to flash Magisk"
2017-06-03 14:19:01 +02:00
;;
2017-12-06 05:51:16 +01:00
5 )
2017-09-15 21:48:58 +02:00
ui_print "! Sony ELF64 format detected"
abort "! Stock kernel cannot be patched, please use a custom kernel"
2017-06-03 14:19:01 +02:00
esac
##########################################################################################
# Ramdisk restores
##########################################################################################
# Test patch status and do restore, after this section, ramdisk.cpio.orig is guaranteed to exist
2017-09-15 21:48:58 +02:00
ui_print "- Checking ramdisk status"
2017-12-20 20:36:18 +01:00
./magiskboot --cpio ramdisk.cpio test
2017-06-03 14:19:01 +02:00
case $? in
0 ) # Stock boot
ui_print "- Stock boot image detected"
2017-09-15 21:48:58 +02:00
ui_print "- Backing up stock boot image"
2017-07-24 20:02:19 +02:00
SHA1=`./magiskboot --sha1 "$BOOTIMAGE" 2>/dev/null`
2017-11-10 18:33:50 +01:00
STOCKDUMP=stock_boot_${SHA1}.img.gz
./magiskboot --compress "$BOOTIMAGE" $STOCKDUMP
2017-06-03 14:19:01 +02:00
cp -af ramdisk.cpio ramdisk.cpio.orig
;;
1 ) # Magisk patched
ui_print "- Magisk patched image detected"
2017-06-03 14:19:01 +02:00
# Find SHA1 of stock boot image
2017-12-20 20:36:18 +01:00
[ -z $SHA1 ] && SHA1=`./magiskboot --cpio ramdisk.cpio sha1 2>/dev/null`
./magiskboot --cpio ramdisk.cpio restore
2017-06-03 14:19:01 +02:00
cp -af ramdisk.cpio ramdisk.cpio.orig
;;
2 ) # Other patched
ui_print "! Boot image patched by other programs"
2017-09-15 21:48:58 +02:00
abort "! Please restore stock boot image"
2017-06-03 14:19:01 +02:00
;;
esac
##########################################################################################
# Ramdisk patches
##########################################################################################
2017-09-15 21:48:58 +02:00
ui_print "- Patching ramdisk"
2017-06-03 14:19:01 +02:00
2017-12-20 20:36:18 +01:00
./magiskboot --cpio ramdisk.cpio \
'add 750 init magiskinit' \
"magisk ramdisk.cpio.orig $HIGHCOMP $KEEPVERITY $KEEPFORCEENCRYPT $SHA1"
2017-06-03 14:19:01 +02:00
rm -f ramdisk.cpio.orig
##########################################################################################
2017-11-10 18:33:50 +01:00
# Binary patches
2017-06-03 14:19:01 +02:00
##########################################################################################
2017-11-10 18:33:50 +01:00
if ! $KEEPVERITY && [ -f dtb ]; then
./magiskboot --dtb-patch dtb && ui_print "- Patching fstab in dtb to remove dm-verity"
fi
2017-06-03 14:19:01 +02:00
# Remove Samsung RKP in stock kernel
2017-06-15 22:08:34 +02:00
./magiskboot --hexpatch kernel \
2017-06-03 14:19:01 +02:00
49010054011440B93FA00F71E9000054010840B93FA00F7189000054001840B91FA00F7188010054 \
A1020054011440B93FA00F7140020054010840B93FA00F71E0010054001840B91FA00F7181010054
2017-09-12 22:07:25 +02:00
# skip_initramfs -> want_initramfs
./magiskboot --hexpatch kernel \
2017-09-12 22:07:25 +02:00
736B69705F696E697472616D6673 \
77616E745F696E697472616D6673
2017-11-10 18:33:50 +01:00
##########################################################################################
# Repack and flash
##########################################################################################
2017-09-15 21:48:58 +02:00
ui_print "- Repacking boot image"
./magiskboot --repack "$BOOTIMAGE" || abort "! Unable to repack boot image!"
2017-06-03 14:19:01 +02:00
2017-07-09 18:17:34 +02:00
# Sign chromeos boot
2017-09-06 10:13:23 +02:00
$CHROMEOS && sign_chromeos
2017-07-09 18:17:34 +02:00
2017-06-15 22:08:34 +02:00
./magiskboot --cleanup